# coding: utf-8

"""
    Readarr

    Readarr API docs

    The version of the OpenAPI document: v0.3.18.2411
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from readarr.models.add_book_options import AddBookOptions
from readarr.models.author_resource import AuthorResource
from readarr.models.book_statistics_resource import BookStatisticsResource
from readarr.models.edition_resource import EditionResource
from readarr.models.links import Links
from readarr.models.media_cover import MediaCover
from readarr.models.ratings import Ratings
from typing import Optional, Set
from typing_extensions import Self

class BookResource(BaseModel):
    """
    BookResource
    """ # noqa: E501
    id: Optional[StrictInt] = None
    title: Optional[StrictStr] = None
    author_title: Optional[StrictStr] = Field(default=None, alias="authorTitle")
    series_title: Optional[StrictStr] = Field(default=None, alias="seriesTitle")
    disambiguation: Optional[StrictStr] = None
    overview: Optional[StrictStr] = None
    author_id: Optional[StrictInt] = Field(default=None, alias="authorId")
    foreign_book_id: Optional[StrictStr] = Field(default=None, alias="foreignBookId")
    foreign_edition_id: Optional[StrictStr] = Field(default=None, alias="foreignEditionId")
    title_slug: Optional[StrictStr] = Field(default=None, alias="titleSlug")
    monitored: Optional[StrictBool] = None
    any_edition_ok: Optional[StrictBool] = Field(default=None, alias="anyEditionOk")
    ratings: Optional[Ratings] = None
    release_date: Optional[datetime] = Field(default=None, alias="releaseDate")
    page_count: Optional[StrictInt] = Field(default=None, alias="pageCount")
    genres: Optional[List[StrictStr]] = None
    author: Optional[AuthorResource] = None
    images: Optional[List[MediaCover]] = None
    links: Optional[List[Links]] = None
    statistics: Optional[BookStatisticsResource] = None
    added: Optional[datetime] = None
    add_options: Optional[AddBookOptions] = Field(default=None, alias="addOptions")
    remote_cover: Optional[StrictStr] = Field(default=None, alias="remoteCover")
    editions: Optional[List[EditionResource]] = None
    grabbed: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["id", "title", "authorTitle", "seriesTitle", "disambiguation", "overview", "authorId", "foreignBookId", "foreignEditionId", "titleSlug", "monitored", "anyEditionOk", "ratings", "releaseDate", "pageCount", "genres", "author", "images", "links", "statistics", "added", "addOptions", "remoteCover", "editions", "grabbed"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BookResource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of ratings
        if self.ratings:
            _dict['ratings'] = self.ratings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of author
        if self.author:
            _dict['author'] = self.author.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in images (list)
        _items = []
        if self.images:
            for _item_images in self.images:
                if _item_images:
                    _items.append(_item_images.to_dict())
            _dict['images'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in links (list)
        _items = []
        if self.links:
            for _item_links in self.links:
                if _item_links:
                    _items.append(_item_links.to_dict())
            _dict['links'] = _items
        # override the default output from pydantic by calling `to_dict()` of statistics
        if self.statistics:
            _dict['statistics'] = self.statistics.to_dict()
        # override the default output from pydantic by calling `to_dict()` of add_options
        if self.add_options:
            _dict['addOptions'] = self.add_options.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in editions (list)
        _items = []
        if self.editions:
            for _item_editions in self.editions:
                if _item_editions:
                    _items.append(_item_editions.to_dict())
            _dict['editions'] = _items
        # set to None if title (nullable) is None
        # and model_fields_set contains the field
        if self.title is None and "title" in self.model_fields_set:
            _dict['title'] = None

        # set to None if author_title (nullable) is None
        # and model_fields_set contains the field
        if self.author_title is None and "author_title" in self.model_fields_set:
            _dict['authorTitle'] = None

        # set to None if series_title (nullable) is None
        # and model_fields_set contains the field
        if self.series_title is None and "series_title" in self.model_fields_set:
            _dict['seriesTitle'] = None

        # set to None if disambiguation (nullable) is None
        # and model_fields_set contains the field
        if self.disambiguation is None and "disambiguation" in self.model_fields_set:
            _dict['disambiguation'] = None

        # set to None if overview (nullable) is None
        # and model_fields_set contains the field
        if self.overview is None and "overview" in self.model_fields_set:
            _dict['overview'] = None

        # set to None if foreign_book_id (nullable) is None
        # and model_fields_set contains the field
        if self.foreign_book_id is None and "foreign_book_id" in self.model_fields_set:
            _dict['foreignBookId'] = None

        # set to None if foreign_edition_id (nullable) is None
        # and model_fields_set contains the field
        if self.foreign_edition_id is None and "foreign_edition_id" in self.model_fields_set:
            _dict['foreignEditionId'] = None

        # set to None if title_slug (nullable) is None
        # and model_fields_set contains the field
        if self.title_slug is None and "title_slug" in self.model_fields_set:
            _dict['titleSlug'] = None

        # set to None if release_date (nullable) is None
        # and model_fields_set contains the field
        if self.release_date is None and "release_date" in self.model_fields_set:
            _dict['releaseDate'] = None

        # set to None if genres (nullable) is None
        # and model_fields_set contains the field
        if self.genres is None and "genres" in self.model_fields_set:
            _dict['genres'] = None

        # set to None if images (nullable) is None
        # and model_fields_set contains the field
        if self.images is None and "images" in self.model_fields_set:
            _dict['images'] = None

        # set to None if links (nullable) is None
        # and model_fields_set contains the field
        if self.links is None and "links" in self.model_fields_set:
            _dict['links'] = None

        # set to None if added (nullable) is None
        # and model_fields_set contains the field
        if self.added is None and "added" in self.model_fields_set:
            _dict['added'] = None

        # set to None if remote_cover (nullable) is None
        # and model_fields_set contains the field
        if self.remote_cover is None and "remote_cover" in self.model_fields_set:
            _dict['remoteCover'] = None

        # set to None if editions (nullable) is None
        # and model_fields_set contains the field
        if self.editions is None and "editions" in self.model_fields_set:
            _dict['editions'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BookResource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "title": obj.get("title"),
            "authorTitle": obj.get("authorTitle"),
            "seriesTitle": obj.get("seriesTitle"),
            "disambiguation": obj.get("disambiguation"),
            "overview": obj.get("overview"),
            "authorId": obj.get("authorId"),
            "foreignBookId": obj.get("foreignBookId"),
            "foreignEditionId": obj.get("foreignEditionId"),
            "titleSlug": obj.get("titleSlug"),
            "monitored": obj.get("monitored"),
            "anyEditionOk": obj.get("anyEditionOk"),
            "ratings": Ratings.from_dict(obj["ratings"]) if obj.get("ratings") is not None else None,
            "releaseDate": obj.get("releaseDate"),
            "pageCount": obj.get("pageCount"),
            "genres": obj.get("genres"),
            "author": AuthorResource.from_dict(obj["author"]) if obj.get("author") is not None else None,
            "images": [MediaCover.from_dict(_item) for _item in obj["images"]] if obj.get("images") is not None else None,
            "links": [Links.from_dict(_item) for _item in obj["links"]] if obj.get("links") is not None else None,
            "statistics": BookStatisticsResource.from_dict(obj["statistics"]) if obj.get("statistics") is not None else None,
            "added": obj.get("added"),
            "addOptions": AddBookOptions.from_dict(obj["addOptions"]) if obj.get("addOptions") is not None else None,
            "remoteCover": obj.get("remoteCover"),
            "editions": [EditionResource.from_dict(_item) for _item in obj["editions"]] if obj.get("editions") is not None else None,
            "grabbed": obj.get("grabbed")
        })
        return _obj


